import { ROOTPATH as baseUrl } from "@/common/config.js"

// 这里的Vue为Vue对象(非创建出来的实例)，vm为main.js中“Vue.use(httpInterceptor, app)”这一句的第二个参数，
// 为一个Vue的实例，也即每个页面的"this"
// 如果需要了解这个install方法是什么，请移步：https://uviewui.com/components/vueUse.html
const install = (Vue, vm) => {
	// 此为自定义配置参数，具体参数见上方说明
	Vue.prototype.$u.http.setConfig({
		baseUrl,
		showLoading: true, // 是否显示请求中的loading
		loadingMask: true, // 展示loading的时候，是否给一个透明的蒙层，防止触摸穿透
		loadingText: '加载中', // 请求loading中的文字提示
		loadingTime: 2000,
		originalData: true, // 是否在拦截器中返回服务端的原始数据
		// 设置自定义头部content-type
		header: {
			'content-type': 'application/json;charset=UTF-8'
		}
	});

	// 请求拦截部分，如配置，每次请求前都会执行
	Vue.prototype.$u.http.interceptor.request = (config) => {
		// 引用token
		let token = vm.vuex_token ? vm.vuex_token : uni.getStorageSync('lifeData')?.vuex_token;
		if (token) {
			config.header['Authorization'] = `Bearer ${token}`;
		}
		return config;
	}

	// 响应拦截，如配置，每次请求结束都会执行本方法
	Vue.prototype.$u.http.interceptor.response = (res) => {
		if (res.statusCode === 200) {
			if (res.data.hasOwnProperty("errcode")) {
				if (res.data.errcode === 40001) {
					Vue.prototype.$u.debounce(() => {
						uni.showToast({
							icon: "none",
							title: "登陆过期，请重新登录"
						})
						setTimeout(() => {
							uni.redirectTo({
								// url: '/package_sub/login/login'
							})
						}, 1500)
					})

				} else {
					uni.showToast({
						icon: "none",
						title: res.data.errmsg||"系统错误"
					})
					return false
				}
			} else
				return res.data;

		} else {
			uni.showToast({
				icon: "fail",
				title: "系统错误"
			})

			return false;
		}
	}
}

export default {
	install
}
